// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package pvktool

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// PvktoolClient is the client API for Pvktool service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type PvktoolClient interface {
	// SearchUsers returns a list of users for a search query
	SearchUsers(ctx context.Context, in *SearchUsersRequest, opts ...grpc.CallOption) (*SearchUsersResponse, error)
	// GetUser returns a user by name
	GetUser(ctx context.Context, in *GetUserRequest, opts ...grpc.CallOption) (*User, error)
	// BatchGetUsers returns a list of users by name
	BatchGetUsers(ctx context.Context, in *BatchGetUsersRequest, opts ...grpc.CallOption) (*BatchGetUsersResponse, error)
	// ListTransactions returns a list of transactions
	ListTransactions(ctx context.Context, in *ListTransactionsRequest, opts ...grpc.CallOption) (*ListTransactionsResponse, error)
	// GetTransaction returns a transaction by name
	GetTransaction(ctx context.Context, in *GetTransactionRequest, opts ...grpc.CallOption) (*Transaction, error)
	// CreateTransaction creates a new transaction
	CreateTransaction(ctx context.Context, in *Transaction, opts ...grpc.CallOption) (*Transaction, error)
	// ListSignups returns a list of signups
	ListSignups(ctx context.Context, in *ListSignupsRequest, opts ...grpc.CallOption) (*ListSignupsResponse, error)
	// GetSignup returns a signup by name
	GetSignup(ctx context.Context, in *GetSignupRequest, opts ...grpc.CallOption) (*Signup, error)
	// CreateSignup creates a new signup
	CreateSignup(ctx context.Context, in *Signup, opts ...grpc.CallOption) (*Signup, error)
	// UpdateSignup update an existing signup
	UpdateSignup(ctx context.Context, in *Signup, opts ...grpc.CallOption) (*Signup, error)
	// ListCategories returns a list of categories
	ListCategories(ctx context.Context, in *ListCategoriesRequest, opts ...grpc.CallOption) (*ListCategoriesResponse, error)
	// GetCategory returns a category by name
	GetCategory(ctx context.Context, in *GetCategoryRequest, opts ...grpc.CallOption) (*Category, error)
	// CreateCategory creates a new category
	CreateCategory(ctx context.Context, in *Category, opts ...grpc.CallOption) (*Category, error)
	// UpdateCategory update an existing category
	UpdateCategory(ctx context.Context, in *Category, opts ...grpc.CallOption) (*Category, error)
	// DeleteCategory deletes an existing category if there are no CourseTopics
	DeleteCategory(ctx context.Context, in *DeleteCategoryRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// ListCourseTopics returns a list of CourseTopics
	ListCourseTopics(ctx context.Context, in *ListCourseTopicsRequest, opts ...grpc.CallOption) (*ListCourseTopicsResponse, error)
	// GetCourseTopic returns a CourseTopic by name
	GetCourseTopic(ctx context.Context, in *GetCourseTopicRequest, opts ...grpc.CallOption) (*CourseTopic, error)
	// CreateCourseTopic creates a new CourseTopic
	CreateCourseTopic(ctx context.Context, in *CourseTopic, opts ...grpc.CallOption) (*CourseTopic, error)
	// UpdateCourseTopic updates an existing CourseTopic
	UpdateCourseTopic(ctx context.Context, in *CourseTopic, opts ...grpc.CallOption) (*CourseTopic, error)
	// DeleteCourseTopic deletes an existing CourseTopic if there were no payment session created
	DeleteCourseTopic(ctx context.Context, in *DeleteCourseTopicRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// ListCourses returns a list of Courses
	ListCourses(ctx context.Context, in *ListCoursesRequest, opts ...grpc.CallOption) (*ListCoursesResponse, error)
	// GetCourse returns an Course by name
	GetCourse(ctx context.Context, in *GetCourseRequest, opts ...grpc.CallOption) (*Course, error)
	// CreateCourse creates a new Course
	CreateCourse(ctx context.Context, in *Course, opts ...grpc.CallOption) (*Course, error)
	// UpdateCourse updates an existing Course
	UpdateCourse(ctx context.Context, in *Course, opts ...grpc.CallOption) (*Course, error)
	// DeleteCourse deletes an existing Course if there were no payment sessions created
	DeleteCourse(ctx context.Context, in *DeleteCourseRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
}

type pvktoolClient struct {
	cc grpc.ClientConnInterface
}

func NewPvktoolClient(cc grpc.ClientConnInterface) PvktoolClient {
	return &pvktoolClient{cc}
}

func (c *pvktoolClient) SearchUsers(ctx context.Context, in *SearchUsersRequest, opts ...grpc.CallOption) (*SearchUsersResponse, error) {
	out := new(SearchUsersResponse)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/SearchUsers", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) GetUser(ctx context.Context, in *GetUserRequest, opts ...grpc.CallOption) (*User, error) {
	out := new(User)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/GetUser", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) BatchGetUsers(ctx context.Context, in *BatchGetUsersRequest, opts ...grpc.CallOption) (*BatchGetUsersResponse, error) {
	out := new(BatchGetUsersResponse)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/BatchGetUsers", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) ListTransactions(ctx context.Context, in *ListTransactionsRequest, opts ...grpc.CallOption) (*ListTransactionsResponse, error) {
	out := new(ListTransactionsResponse)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/ListTransactions", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) GetTransaction(ctx context.Context, in *GetTransactionRequest, opts ...grpc.CallOption) (*Transaction, error) {
	out := new(Transaction)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/GetTransaction", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) CreateTransaction(ctx context.Context, in *Transaction, opts ...grpc.CallOption) (*Transaction, error) {
	out := new(Transaction)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/CreateTransaction", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) ListSignups(ctx context.Context, in *ListSignupsRequest, opts ...grpc.CallOption) (*ListSignupsResponse, error) {
	out := new(ListSignupsResponse)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/ListSignups", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) GetSignup(ctx context.Context, in *GetSignupRequest, opts ...grpc.CallOption) (*Signup, error) {
	out := new(Signup)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/GetSignup", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) CreateSignup(ctx context.Context, in *Signup, opts ...grpc.CallOption) (*Signup, error) {
	out := new(Signup)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/CreateSignup", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) UpdateSignup(ctx context.Context, in *Signup, opts ...grpc.CallOption) (*Signup, error) {
	out := new(Signup)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/UpdateSignup", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) ListCategories(ctx context.Context, in *ListCategoriesRequest, opts ...grpc.CallOption) (*ListCategoriesResponse, error) {
	out := new(ListCategoriesResponse)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/ListCategories", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) GetCategory(ctx context.Context, in *GetCategoryRequest, opts ...grpc.CallOption) (*Category, error) {
	out := new(Category)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/GetCategory", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) CreateCategory(ctx context.Context, in *Category, opts ...grpc.CallOption) (*Category, error) {
	out := new(Category)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/CreateCategory", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) UpdateCategory(ctx context.Context, in *Category, opts ...grpc.CallOption) (*Category, error) {
	out := new(Category)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/UpdateCategory", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) DeleteCategory(ctx context.Context, in *DeleteCategoryRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/DeleteCategory", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) ListCourseTopics(ctx context.Context, in *ListCourseTopicsRequest, opts ...grpc.CallOption) (*ListCourseTopicsResponse, error) {
	out := new(ListCourseTopicsResponse)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/ListCourseTopics", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) GetCourseTopic(ctx context.Context, in *GetCourseTopicRequest, opts ...grpc.CallOption) (*CourseTopic, error) {
	out := new(CourseTopic)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/GetCourseTopic", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) CreateCourseTopic(ctx context.Context, in *CourseTopic, opts ...grpc.CallOption) (*CourseTopic, error) {
	out := new(CourseTopic)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/CreateCourseTopic", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) UpdateCourseTopic(ctx context.Context, in *CourseTopic, opts ...grpc.CallOption) (*CourseTopic, error) {
	out := new(CourseTopic)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/UpdateCourseTopic", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) DeleteCourseTopic(ctx context.Context, in *DeleteCourseTopicRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/DeleteCourseTopic", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) ListCourses(ctx context.Context, in *ListCoursesRequest, opts ...grpc.CallOption) (*ListCoursesResponse, error) {
	out := new(ListCoursesResponse)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/ListCourses", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) GetCourse(ctx context.Context, in *GetCourseRequest, opts ...grpc.CallOption) (*Course, error) {
	out := new(Course)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/GetCourse", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) CreateCourse(ctx context.Context, in *Course, opts ...grpc.CallOption) (*Course, error) {
	out := new(Course)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/CreateCourse", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) UpdateCourse(ctx context.Context, in *Course, opts ...grpc.CallOption) (*Course, error) {
	out := new(Course)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/UpdateCourse", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pvktoolClient) DeleteCourse(ctx context.Context, in *DeleteCourseRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.amiv.pvktool.Pvktool/DeleteCourse", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// PvktoolServer is the server API for Pvktool service.
// All implementations must embed UnimplementedPvktoolServer
// for forward compatibility
type PvktoolServer interface {
	// SearchUsers returns a list of users for a search query
	SearchUsers(context.Context, *SearchUsersRequest) (*SearchUsersResponse, error)
	// GetUser returns a user by name
	GetUser(context.Context, *GetUserRequest) (*User, error)
	// BatchGetUsers returns a list of users by name
	BatchGetUsers(context.Context, *BatchGetUsersRequest) (*BatchGetUsersResponse, error)
	// ListTransactions returns a list of transactions
	ListTransactions(context.Context, *ListTransactionsRequest) (*ListTransactionsResponse, error)
	// GetTransaction returns a transaction by name
	GetTransaction(context.Context, *GetTransactionRequest) (*Transaction, error)
	// CreateTransaction creates a new transaction
	CreateTransaction(context.Context, *Transaction) (*Transaction, error)
	// ListSignups returns a list of signups
	ListSignups(context.Context, *ListSignupsRequest) (*ListSignupsResponse, error)
	// GetSignup returns a signup by name
	GetSignup(context.Context, *GetSignupRequest) (*Signup, error)
	// CreateSignup creates a new signup
	CreateSignup(context.Context, *Signup) (*Signup, error)
	// UpdateSignup update an existing signup
	UpdateSignup(context.Context, *Signup) (*Signup, error)
	// ListCategories returns a list of categories
	ListCategories(context.Context, *ListCategoriesRequest) (*ListCategoriesResponse, error)
	// GetCategory returns a category by name
	GetCategory(context.Context, *GetCategoryRequest) (*Category, error)
	// CreateCategory creates a new category
	CreateCategory(context.Context, *Category) (*Category, error)
	// UpdateCategory update an existing category
	UpdateCategory(context.Context, *Category) (*Category, error)
	// DeleteCategory deletes an existing category if there are no CourseTopics
	DeleteCategory(context.Context, *DeleteCategoryRequest) (*emptypb.Empty, error)
	// ListCourseTopics returns a list of CourseTopics
	ListCourseTopics(context.Context, *ListCourseTopicsRequest) (*ListCourseTopicsResponse, error)
	// GetCourseTopic returns a CourseTopic by name
	GetCourseTopic(context.Context, *GetCourseTopicRequest) (*CourseTopic, error)
	// CreateCourseTopic creates a new CourseTopic
	CreateCourseTopic(context.Context, *CourseTopic) (*CourseTopic, error)
	// UpdateCourseTopic updates an existing CourseTopic
	UpdateCourseTopic(context.Context, *CourseTopic) (*CourseTopic, error)
	// DeleteCourseTopic deletes an existing CourseTopic if there were no payment session created
	DeleteCourseTopic(context.Context, *DeleteCourseTopicRequest) (*emptypb.Empty, error)
	// ListCourses returns a list of Courses
	ListCourses(context.Context, *ListCoursesRequest) (*ListCoursesResponse, error)
	// GetCourse returns an Course by name
	GetCourse(context.Context, *GetCourseRequest) (*Course, error)
	// CreateCourse creates a new Course
	CreateCourse(context.Context, *Course) (*Course, error)
	// UpdateCourse updates an existing Course
	UpdateCourse(context.Context, *Course) (*Course, error)
	// DeleteCourse deletes an existing Course if there were no payment sessions created
	DeleteCourse(context.Context, *DeleteCourseRequest) (*emptypb.Empty, error)
	mustEmbedUnimplementedPvktoolServer()
}

// UnimplementedPvktoolServer must be embedded to have forward compatible implementations.
type UnimplementedPvktoolServer struct {
}

func (UnimplementedPvktoolServer) SearchUsers(context.Context, *SearchUsersRequest) (*SearchUsersResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SearchUsers not implemented")
}
func (UnimplementedPvktoolServer) GetUser(context.Context, *GetUserRequest) (*User, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetUser not implemented")
}
func (UnimplementedPvktoolServer) BatchGetUsers(context.Context, *BatchGetUsersRequest) (*BatchGetUsersResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method BatchGetUsers not implemented")
}
func (UnimplementedPvktoolServer) ListTransactions(context.Context, *ListTransactionsRequest) (*ListTransactionsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListTransactions not implemented")
}
func (UnimplementedPvktoolServer) GetTransaction(context.Context, *GetTransactionRequest) (*Transaction, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetTransaction not implemented")
}
func (UnimplementedPvktoolServer) CreateTransaction(context.Context, *Transaction) (*Transaction, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateTransaction not implemented")
}
func (UnimplementedPvktoolServer) ListSignups(context.Context, *ListSignupsRequest) (*ListSignupsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListSignups not implemented")
}
func (UnimplementedPvktoolServer) GetSignup(context.Context, *GetSignupRequest) (*Signup, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetSignup not implemented")
}
func (UnimplementedPvktoolServer) CreateSignup(context.Context, *Signup) (*Signup, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateSignup not implemented")
}
func (UnimplementedPvktoolServer) UpdateSignup(context.Context, *Signup) (*Signup, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateSignup not implemented")
}
func (UnimplementedPvktoolServer) ListCategories(context.Context, *ListCategoriesRequest) (*ListCategoriesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListCategories not implemented")
}
func (UnimplementedPvktoolServer) GetCategory(context.Context, *GetCategoryRequest) (*Category, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetCategory not implemented")
}
func (UnimplementedPvktoolServer) CreateCategory(context.Context, *Category) (*Category, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateCategory not implemented")
}
func (UnimplementedPvktoolServer) UpdateCategory(context.Context, *Category) (*Category, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateCategory not implemented")
}
func (UnimplementedPvktoolServer) DeleteCategory(context.Context, *DeleteCategoryRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteCategory not implemented")
}
func (UnimplementedPvktoolServer) ListCourseTopics(context.Context, *ListCourseTopicsRequest) (*ListCourseTopicsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListCourseTopics not implemented")
}
func (UnimplementedPvktoolServer) GetCourseTopic(context.Context, *GetCourseTopicRequest) (*CourseTopic, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetCourseTopic not implemented")
}
func (UnimplementedPvktoolServer) CreateCourseTopic(context.Context, *CourseTopic) (*CourseTopic, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateCourseTopic not implemented")
}
func (UnimplementedPvktoolServer) UpdateCourseTopic(context.Context, *CourseTopic) (*CourseTopic, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateCourseTopic not implemented")
}
func (UnimplementedPvktoolServer) DeleteCourseTopic(context.Context, *DeleteCourseTopicRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteCourseTopic not implemented")
}
func (UnimplementedPvktoolServer) ListCourses(context.Context, *ListCoursesRequest) (*ListCoursesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListCourses not implemented")
}
func (UnimplementedPvktoolServer) GetCourse(context.Context, *GetCourseRequest) (*Course, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetCourse not implemented")
}
func (UnimplementedPvktoolServer) CreateCourse(context.Context, *Course) (*Course, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateCourse not implemented")
}
func (UnimplementedPvktoolServer) UpdateCourse(context.Context, *Course) (*Course, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateCourse not implemented")
}
func (UnimplementedPvktoolServer) DeleteCourse(context.Context, *DeleteCourseRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteCourse not implemented")
}
func (UnimplementedPvktoolServer) mustEmbedUnimplementedPvktoolServer() {}

// UnsafePvktoolServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to PvktoolServer will
// result in compilation errors.
type UnsafePvktoolServer interface {
	mustEmbedUnimplementedPvktoolServer()
}

func RegisterPvktoolServer(s grpc.ServiceRegistrar, srv PvktoolServer) {
	s.RegisterService(&Pvktool_ServiceDesc, srv)
}

func _Pvktool_SearchUsers_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SearchUsersRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).SearchUsers(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/SearchUsers",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).SearchUsers(ctx, req.(*SearchUsersRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_GetUser_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetUserRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).GetUser(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/GetUser",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).GetUser(ctx, req.(*GetUserRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_BatchGetUsers_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BatchGetUsersRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).BatchGetUsers(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/BatchGetUsers",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).BatchGetUsers(ctx, req.(*BatchGetUsersRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_ListTransactions_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListTransactionsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).ListTransactions(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/ListTransactions",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).ListTransactions(ctx, req.(*ListTransactionsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_GetTransaction_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetTransactionRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).GetTransaction(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/GetTransaction",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).GetTransaction(ctx, req.(*GetTransactionRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_CreateTransaction_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Transaction)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).CreateTransaction(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/CreateTransaction",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).CreateTransaction(ctx, req.(*Transaction))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_ListSignups_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListSignupsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).ListSignups(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/ListSignups",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).ListSignups(ctx, req.(*ListSignupsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_GetSignup_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetSignupRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).GetSignup(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/GetSignup",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).GetSignup(ctx, req.(*GetSignupRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_CreateSignup_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Signup)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).CreateSignup(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/CreateSignup",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).CreateSignup(ctx, req.(*Signup))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_UpdateSignup_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Signup)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).UpdateSignup(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/UpdateSignup",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).UpdateSignup(ctx, req.(*Signup))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_ListCategories_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListCategoriesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).ListCategories(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/ListCategories",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).ListCategories(ctx, req.(*ListCategoriesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_GetCategory_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetCategoryRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).GetCategory(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/GetCategory",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).GetCategory(ctx, req.(*GetCategoryRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_CreateCategory_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Category)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).CreateCategory(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/CreateCategory",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).CreateCategory(ctx, req.(*Category))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_UpdateCategory_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Category)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).UpdateCategory(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/UpdateCategory",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).UpdateCategory(ctx, req.(*Category))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_DeleteCategory_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteCategoryRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).DeleteCategory(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/DeleteCategory",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).DeleteCategory(ctx, req.(*DeleteCategoryRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_ListCourseTopics_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListCourseTopicsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).ListCourseTopics(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/ListCourseTopics",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).ListCourseTopics(ctx, req.(*ListCourseTopicsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_GetCourseTopic_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetCourseTopicRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).GetCourseTopic(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/GetCourseTopic",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).GetCourseTopic(ctx, req.(*GetCourseTopicRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_CreateCourseTopic_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CourseTopic)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).CreateCourseTopic(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/CreateCourseTopic",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).CreateCourseTopic(ctx, req.(*CourseTopic))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_UpdateCourseTopic_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CourseTopic)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).UpdateCourseTopic(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/UpdateCourseTopic",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).UpdateCourseTopic(ctx, req.(*CourseTopic))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_DeleteCourseTopic_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteCourseTopicRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).DeleteCourseTopic(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/DeleteCourseTopic",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).DeleteCourseTopic(ctx, req.(*DeleteCourseTopicRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_ListCourses_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListCoursesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).ListCourses(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/ListCourses",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).ListCourses(ctx, req.(*ListCoursesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_GetCourse_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetCourseRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).GetCourse(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/GetCourse",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).GetCourse(ctx, req.(*GetCourseRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_CreateCourse_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Course)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).CreateCourse(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/CreateCourse",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).CreateCourse(ctx, req.(*Course))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_UpdateCourse_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Course)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).UpdateCourse(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/UpdateCourse",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).UpdateCourse(ctx, req.(*Course))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pvktool_DeleteCourse_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteCourseRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PvktoolServer).DeleteCourse(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.amiv.pvktool.Pvktool/DeleteCourse",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PvktoolServer).DeleteCourse(ctx, req.(*DeleteCourseRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Pvktool_ServiceDesc is the grpc.ServiceDesc for Pvktool service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Pvktool_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.amiv.pvktool.Pvktool",
	HandlerType: (*PvktoolServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "SearchUsers",
			Handler:    _Pvktool_SearchUsers_Handler,
		},
		{
			MethodName: "GetUser",
			Handler:    _Pvktool_GetUser_Handler,
		},
		{
			MethodName: "BatchGetUsers",
			Handler:    _Pvktool_BatchGetUsers_Handler,
		},
		{
			MethodName: "ListTransactions",
			Handler:    _Pvktool_ListTransactions_Handler,
		},
		{
			MethodName: "GetTransaction",
			Handler:    _Pvktool_GetTransaction_Handler,
		},
		{
			MethodName: "CreateTransaction",
			Handler:    _Pvktool_CreateTransaction_Handler,
		},
		{
			MethodName: "ListSignups",
			Handler:    _Pvktool_ListSignups_Handler,
		},
		{
			MethodName: "GetSignup",
			Handler:    _Pvktool_GetSignup_Handler,
		},
		{
			MethodName: "CreateSignup",
			Handler:    _Pvktool_CreateSignup_Handler,
		},
		{
			MethodName: "UpdateSignup",
			Handler:    _Pvktool_UpdateSignup_Handler,
		},
		{
			MethodName: "ListCategories",
			Handler:    _Pvktool_ListCategories_Handler,
		},
		{
			MethodName: "GetCategory",
			Handler:    _Pvktool_GetCategory_Handler,
		},
		{
			MethodName: "CreateCategory",
			Handler:    _Pvktool_CreateCategory_Handler,
		},
		{
			MethodName: "UpdateCategory",
			Handler:    _Pvktool_UpdateCategory_Handler,
		},
		{
			MethodName: "DeleteCategory",
			Handler:    _Pvktool_DeleteCategory_Handler,
		},
		{
			MethodName: "ListCourseTopics",
			Handler:    _Pvktool_ListCourseTopics_Handler,
		},
		{
			MethodName: "GetCourseTopic",
			Handler:    _Pvktool_GetCourseTopic_Handler,
		},
		{
			MethodName: "CreateCourseTopic",
			Handler:    _Pvktool_CreateCourseTopic_Handler,
		},
		{
			MethodName: "UpdateCourseTopic",
			Handler:    _Pvktool_UpdateCourseTopic_Handler,
		},
		{
			MethodName: "DeleteCourseTopic",
			Handler:    _Pvktool_DeleteCourseTopic_Handler,
		},
		{
			MethodName: "ListCourses",
			Handler:    _Pvktool_ListCourses_Handler,
		},
		{
			MethodName: "GetCourse",
			Handler:    _Pvktool_GetCourse_Handler,
		},
		{
			MethodName: "CreateCourse",
			Handler:    _Pvktool_CreateCourse_Handler,
		},
		{
			MethodName: "UpdateCourse",
			Handler:    _Pvktool_UpdateCourse_Handler,
		},
		{
			MethodName: "DeleteCourse",
			Handler:    _Pvktool_DeleteCourse_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "vseth/amiv/pvktool/pvktool.proto",
}
